# mathslib

 A compilation of Mathematical Functions and Algorithms I have made or come across.
 I have used most of these for [Project Euler](https://projecteuler.net/about)
 
 You can see their implementation on my website [ivl-projecteuler](https://www.ivl-projecteuler.com/)

# Modules

<table>
  <tbody>
    <tr>
      <th>Modules</th>
      <th align="center">Functions</th>
    </tr>
    <tr>
      <td>numtheory.py</td>
      <td align="center">        
       <ul>
          <li><code>divisors_of(x, include_x)</code></li>
          <li><code>divisors(x, n)</code></li>
          <li><code>continued_fraction(x)</code></li>
          <li><code>continued_fraction(x)</code></li>
          <li><code>overall_fraction(x)</code></li>
          <li><code>phi(x)</code></li>
          <li><code>Mobius(x)</code></li>
          <li><code>ppt(limit, non_primitive)</code></li>
          <li><code>legendre_factorial(x)</code></li>
          <li><code>k_smooth_numbers(max_prime, limit)</code></li>
          <li><code>legendre_symbol(a, p)</code></li>
          <li><code>tonelli_shanks(a, p)</code></li>
          <li><code>ChineseRemainderTheorem(a1, a2, n1, n2)</code></li>
        </ul>
     </td>
    </tr>
    <tr>
      <td>prime.py</td>
      <td align="center">
         <ul>
          <li><code>Prime_Sieve(limit, block_size, segment, values)</code></li>
          <li><code>is_prime(x)</code></li>
          <li><code>prime_factors(x)</code></li>
        </ul>
      </td>
    </tr>
    <tr>
      <td>fib.py</td>
      <td align="center">
       <ul>
          <li><code>fibonacci(n)</code></li>
          <li><code>fib_till(limit)</code></li>
          <li><code>ZeckendorfRepresentation(x)</code></li>
        </ul>
      </td>
    </tr>
    <tr>
      <td>algorithms.py </td>
      <td align="center">
       <ul>
          <li><code>PrimsAlgorithm(matrix)</code></li>
          <li><code>DijkstrasAlgorithm(matrix, start_node, end_node)</code></li>
          <li><code>KnapSack(values, weights, n, W, no_values)</code></li>
          <li><code>KnapSackValues(values, weights, n, W)</code></li>
        </ul>
      </td>
    </tr>
    <tr>
       <td>simple.py</td>
       <td align="center">
        <ul>
          <li><code>n_choose_r(n, r)</code></li>
          <li><code>numberToBase(n, b)</code></li>
          <li><code>lcm(a_list)</code></li>
          <li><code>ModDivision(a, b, m)</code></li>
        </ul>
       </td>
     </tr>
  </tbody>
</table>
